package com.practice;

import java.util.Arrays;
import java.util.List;

// pojo class
class User {
	private int id;
	private String name;
	
	public User(int id, String name) {
		this.id = id;
		this.name = name;
	}
	
	public int getId() {
		return id;
	}
	
	public String getName() {
		return name;
	}
	
	@Override
	public String toString() {
		return "[id=" + id + ", name=" + name + "]";
	}
	
	public static List<User> createUsers() {
		return Arrays.asList(new User(101, "abc"), new User(102, "pqr"));
	}
}

// implementation class
public class ArraysAsListExample {

	// syntax - static <T> List<T> asList(T... a)
	
	private static void example1() {
		List<String> elements = Arrays.asList("apple", "banana", "kiwi", "mango");
		System.out.println(elements);
	}
	
	private static void example2() {
		List<User> users = User.createUsers();
		users.forEach(user -> System.out.println(user));
	}
	
	private static void example3() {
		List<User> users = User.createUsers();
		users.forEach(user -> System.out.println(user));
		
		// adding new element to the list
		// will throw java.lang.UnsupportedOperationException
		users.add(new User(103, "rst"));
	}
	
	// driver code
	public static void main(String[] args) {
		example1();
		System.out.println("\n");
		example2();
		System.out.println("\n");
		example3();
	}
}
